/*
bthxmem.c Version 0.1.0 Btree print memory in hex
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void bthxmem(len,mem)
int len;
unsigned char *mem;
   {
   int linelen;
   int adr;
   unsigned char *p,*q;
   if (mem == NULL)
      {
      printf("bthxmem: NULL\n");
      return;
      } /* null memory */
   adr = 0;
   p = mem;
   q = mem + len;
   while (p < q)
      {
      linelen = q - p;
      if (linelen > 16) linelen = 16;
      btputhx(adr,linelen,p);
      adr += 16;
      p   += 16;
      } /* for each 16 */
   } /* bthxmem */
