/*
btputblk.c Version 0.1.0  Btree write database block
Copyright (C) 2003  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

#include <bthash.h>

void btputblk(bthdr,ofst,blk)
btreefmt *bthdr;
off_t ofst;
blkfmt *blk;
   {
   int wrtlen;
   off_t loc;
   bthdr->reason = 0;
   loc = btseek(bthdr,ofst);
   if (bthdr->reason) return;
   wrtlen = write(bthdr->hndl,blk,bthdr->blksz);
   if (wrtlen == bthdr->blksz)
      return;
   else if (wrtlen < 0)
      {
      fprintf(stderr,"Errno %d\n", errno);
      perror("Write error");
      bthdr->reason = SYS_ERR + errno;;
      return;
      } /* write error */
   else
      {
      fprintf(stderr,"Write error (wrtlen %d)", wrtlen);
      bthdr->reason = BTREE_ERR + 1501;
      return;
      } /* write error */
   } /* btputblk */
